org.custommonkey.xmlunit

## Class DetailedDiff

- java.lang.Object
- - org.custommonkey.xmlunit.Diff
  - - org.custommonkey.xmlunit.DetailedDiff

All Implemented Interfaces:
  ComparisonController, DifferenceListener

    public class DetailedDiff
    extends Diff

Compares and describes all the differences between two XML documents. The document comparison does not stop once the first unrecoverable difference is found, unlike the Diff class. Note that because the differences are described relative to some control XML the list of all differences when A is compared to B will not necessarily be the same as when B is compared to A.
Examples and more at xmlunit.sourceforge.net

### Field Summary

### Fields inherited from interface org.custommonkey.xmlunit.DifferenceListener

`RETURN_ACCEPT_DIFFERENCE, RETURN_IGNORE_DIFFERENCE_NODES_IDENTICAL, RETURN_IGNORE_DIFFERENCE_NODES_SIMILAR, RETURN_UPGRADE_DIFFERENCE_NODES_DIFFERENT`

### Constructor Summary

Constructors
Constructor and Description
`DetailedDiff(Diff prototype)` Create a new instance based on a prototypical Diff instance

### Method Summary

Methods
`int` `differenceFound(Difference difference)` DifferenceListener implementation.
`java.util.List` `getAllDifferences()` Obtain all the differences found by this instance
`boolean` `haltComparison(Difference afterDifference)` ComparisonController implementation.

### Methods inherited from class org.custommonkey.xmlunit.Diff

`appendMessage, compare, identical, overrideDifferenceListener, overrideElementQualifier, overrideMatchTracker, similar, skippedComparison, toString`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### DetailedDiff

    public DetailedDiff(Diff prototype)

Create a new instance based on a prototypical Diff instance

Parameters:
  `prototype` - the Diff instance for which more detailed difference information is required

### Method Detail

#### differenceFound

    public int differenceFound(Difference difference)

DifferenceListener implementation. Add the difference to the list of all differences

Specified by:
  `differenceFound` in interface `DifferenceListener`
Overrides:
  `differenceFound` in class `Diff`
Parameters:
  `expected` -
  `actual` -
  `control` -
  `test` -
  `comparingWhat` -
Returns:
  the value supplied by the superclass implementation

#### haltComparison

    public boolean haltComparison(Difference afterDifference)

ComparisonController implementation.

Specified by:
  `haltComparison` in interface `ComparisonController`
Overrides:
  `haltComparison` in class `Diff`
Parameters:
  `afterDifference` -
Returns:
  false always as this class wants to see all differences
See Also:
  `Difference.isRecoverable()`

#### getAllDifferences

    public java.util.List getAllDifferences()

Obtain all the differences found by this instance

Returns:
  a list of `differences`